﻿Type=StaticCode
Version=1.50
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	xmlloadfile = "ws_resp.xml"

End Sub

Sub CallWebService(opName As String, parameters As Map, url As String)

	Dim XML As String
	XML = 	"<?xml version='1.0' encoding='utf-8'?>" & _
			"<soap12:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap12='http://www.w3.org/2003/05/soap-envelope'>" & _
				"<soap12:Body>" & _
					"<" & opName & "  xmlns='http://sendem.com/'>" 
					
	For i = 0 To parameters.Size -1
		XML = XML & "<" & parameters.GetKeyAt(i) & ">" & parameters.GetValueAt(i) & "</" & parameters.GetKeyAt(i) & ">" 
	Next	
					
	XML = XML &	"</" & opName & ">" & _
			"</soap12:Body>" & _
		"</soap12:Envelope>"
	
	XML = XML.Replace("'", Chr(34))
	Log("XML post: " & xml)
	HttpUtils.PostString(opName, url, XML)

End Sub

Sub CallWebServiceXML(opName As String, xmlParamName As String, level1 As String, level2 As String, parameters As Map, url As String)
'	<?xml version="1.0" encoding="utf-8"?>
'	<soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
'	<soap12:Body>
'		<ReceiveMobileJobXML xmlns="http://sendem.com/">
'		<MobileJobs><Job>
'		<XMLdetails>String</XMLdetails>
'		</Job></MobileJobs> 
'		</ReceiveMobileJobXML>
'	</soap12:Body>
'	</soap12:Envelope>

	Dim XML As String
	XML = 	"<?xml version='1.0' encoding='utf-8'?>" & _
			"<soap12:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap12='http://www.w3.org/2003/05/soap-envelope'>" & _
			"<soap12:Body>" & _
				"<" & opName & "  xmlns='http://sendem.com/'>" & _ 
				"<" & xmlParamName & ">" & _
				"<Job>"
					
	For i = 0 To parameters.Size -1
		XML = XML & "<" & parameters.GetKeyAt(i) & ">" & parameters.GetValueAt(i) & "</" & parameters.GetKeyAt(i) & ">" 
	Next	
					
	XML = XML & "</Job>" & _
				"</" & xmlParamName & ">" & _
				"</" & opName & ">" & _
			"</soap12:Body>" & _
		"</soap12:Envelope>"
	
	XML = XML.Replace("'", Chr(34))
		
	Log("XML post: " & xml)
	HttpUtils.PostString(opName, url, XML)


'	Dim XML As String
'	XML = 	"<?xml version='1.0' encoding='utf-8'?>" & _
'			"<soap12:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap12='http://www.w3.org/2003/05/soap-envelope'>" & _
'			"<soap12:Body>" & _
'				"<" & opName & "  xmlns='http://sendem.com/'>" & _ 
'				"<" & xmlParamName & ">" & _
'				"<" & level1 & "><" & level2 & ">" 
'					
'	For i = 0 To parameters.Size -1
'		XML = XML & "<" & parameters.GetKeyAt(i) & ">" & parameters.GetValueAt(i) & "</" & parameters.GetKeyAt(i) & ">" 
'	Next	
'					
'	XML = XML & "</" & level2 & "></" & level1 & ">" & _
'				"</" & xmlParamName & ">" & _
'				"</" & opName & ">" & _
'			"</soap12:Body>" & _
'		"</soap12:Envelope>"
'	
'	XML = XML.Replace("'", Chr(34))
'		
'	Log("XML post: " & xml)
'	HttpUtils.PostString(opName, url, XML)

End Sub

Sub GetWebServiceDataStream (IDtag As String, url As String, action As String) As InputStream
' ID tag contains the XML container element for the required entity, e.g. "MobileJobs"

	Dim s1 As String, s2 As InputStream, p1 As Int, p2 As Int
	If HttpUtils.IsSuccess(url) Then
		s1 = HttpUtils.GetString(url)
		s1 = s1.Replace("&lt;", "<").Replace("&gt;", ">").Replace("#x0a;", Chr(13) & Chr(10)).Replace("&amp;","&")

		Dim tag As String
		tag = "<" & IDtag & ">"
		p1 = s1.IndexOf(tag)
 		p2 = s1.IndexOf(tag.Replace("<", "</"))
		If (p1 <> -1) AND (p2 <> -1) Then
 			s1 = s1.SubString2(p1, p2 + tag.length +1)
		End If
		File.WriteString(File.DirInternalCache, xmlloadfile, s1)
		s2 = File.OpenInput(File.DirInternalCache, xmlloadfile)
		Return s2
	End If
End Sub

Sub GetWebServiceResponseString (IDtag As String, url As String, action As String) As String	
' ID tag contains the XML container element for the required entity, e.g. "MobileJobs"
' this version STRIPS the container tag, returning just the Response

	Dim s1 As String, p1 As Int, p2 As Int
	If HttpUtils.IsSuccess(url) Then
		s1 = HttpUtils.GetString(url)
		s1 = s1.Replace("&lt;", "<").Replace("&gt;", ">").Replace("#x0a;", Chr(13) & Chr(10)).Replace("&amp;","&")
	
		Dim tag As String
		tag = "<" & IDtag & ">"
		p1 = s1.IndexOf(tag)
 		p2 = s1.IndexOf(tag.Replace("<", "</"))
		If (p1 <> -1) AND (p2 <> -1) Then
 			s1 = s1.SubString2(p1  + tag.length, p2)
		Else
			s1 = ""
		End If
		Return s1
	End If
End Sub
